#Demo of singular value decomposition with numpy

import numpy

#Define a matrix A to be decomposed
A = numpy.matrix([[4,11,14],[8,7,-2]])

#Do the decomposition by calling numpy.linalg.svd
U,S,VT = numpy.linalg.svd(A)

#Note that unlike matlab, numpy returns the transpose of the V matrix,
#not the V matrix itself. Also unlike matlab, numpy gives S as an array
#of the singular values, not as the sigma matrix. To create the sigma matrix,
#we may do the following.

#Create an "empty" matrix with same dimensions as A
Sigma = numpy.zeros(A.shape)

#Fill it with the singular values on the "diagonal"
for i in xrange(len(S)):
    Sigma[i,i] = S[i]

#Print matrices
print 'A ='
print A
print 'U ='
print U
print 'S ='
print S
print 'Sigma ='
print Sigma
print 'VT ='
print VT
print 'U * Sigma * VT ='
print U*Sigma*VT
