#include <iostream>
#include "Graphics.h"
#include <math.h>
#include <time.h>

using namespace std;

Graphics g;
int W = 400; // Bredde
int H = 400;  // Hyde

// Hva skjer hvis vi lar N g til uendelig? Forsk N = 10 000, 100 000 og 1 000 000!

/*
  Eksempel p random walk (drunkards walk)
*/

int main(int a, char *b[])
{
  // pner vindu
  g.openWindow("Eksempel p random walk",W,H);

  if (a!=3) {
    cout <<"usage: ./randomwalk <number of walkers> <stepsize (like 1 or 100)>\n";
    return 0;
  }

  int N = atoi(b[1]);
  int stepmax = atoi(b[2]);

  // Initialiser random variable
  srand ( time(NULL) );  
  
  // 3 buffers allokeres: lsningen, frstederiverte og andrederiverte

  int* x = new int[N]; //x-pos 
  int* y = new int[N];//y-pos

  int *avg = new int[W];  

  // initaliser alle fyllikene i midten
  for (int i=0;i<N;i++) {
           x[i] = 0;
           y[i] = 0;
      }


  // Denne tar seg av events som tastetrykk o.l
  SDL_Event event;
  int step = 0;

  // Hovedlkken : denne kjres for alltid
  while(1)
    {
      // Renser skjermen med sort bakgrunn. hva skjer hvis vi fjerner denne? Forsk!


      // iterr
      for (int i=0;i<N;i++) {
          
	int verdi=1;
          if (rand()%100<50) verdi = -verdi;

          if (rand()%100<50) {// opp-ned
            x[i] = x[i] + verdi;
	  }
          else
            y[i] = y[i] + verdi; 
            
      }   


      // Calculate average x

      for (int i=0;i<W;i++) 
	avg[i] = 0;


      for (int i=0;i<N;i++) {
	int d = x[i];
	if (d<(W/2-2) && (d>-(W/2-2))) 
	    avg[W/2 + d]+=1;
	
      }
      // Scale
      int max = 0;
      for (int i=0;i<W;i++) {
	if (avg[i]>max)
	  max = avg[i];
      }
      double scale = H/(double)(3*max);

      if (step++==stepmax) {
	step = 0;




	g.Clear(0);

      // Tegner lsningen : et par pixel pr mann
	for (int i=0;i<N;i++) {
	  g.largestpixel(x[i] + W/2,y[i] + H/2,100,255,255);
	  }
      

	for (int i=0;i<W-1;i++) { 
	  int y1 = W-30 - (int)(avg[i]*scale);
	  int y2 = W-30 - (int)(avg[i+1]*scale);
	  g.line(i,y1,i+1,y2,255,90,20);
	}
	g.flip();

      }


       
      
      // presentr til skjerm
      
      // Sjekk om diverse tastetrykk
      while ( SDL_PollEvent(&event) ) {
	        switch (event.type) {
 	              case SDL_QUIT:
	                   exit(0);
                  case SDL_KEYDOWN:
	                   exit(0); // Avslutt hvis envher tast er trykket
	  
            }   
      }
    }

  // Husk  rense opp minnet!
  delete[] x;
  delete[] y;
  return 0;
}
